"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 *  @name MArray
 *  @description MArray
 *  @author GuoBin201314@gmail.com
 *  @date 2018/11/18 20:53
 */
var MArray = /** @class */ (function () {
    function MArray() {
    }
    /**
     * 数组分块
     * @param arr Array
     * @param size Number
     */
    MArray.chunk = function (arr, size) {
        return Array.from({ length: Math.ceil(arr.length / size) }, function (v, i) {
            return arr.slice(i * size, i * size + size);
        });
    };
    /**
     * 过滤假值元素(false, null, 0, "", undefined, 和 NaN)
     * @param arr
     */
    MArray.compact = function (arr) { return arr.filter(Boolean); };
    /**
     * 计算元素出现的次数
     * @param arr
     * @param val
     */
    MArray.occurrence = function (arr, val) {
        arr.reduce(function (a, v) {
            return v === val ? a + 1 : a + 0;
        }, 0);
    };
    /**
     * 平铺数组
     * @param arr
     */
    MArray.deepFlatten = function (arr) {
        return [].concat.apply([], arr.map(function (v) { return (Array.isArray(v) ? MArray.deepFlatten(v) : v); }));
    };
    /**
     * 数组比较差异
     * @param a
     * @param b
     */
    MArray.difference = function (a, b) {
        var s = new Set(b);
        return a.filter(function (x) { return !s.has(x); });
    };
    /**
     * 通过比较函数比较数组之间的差异
     * @param arr
     * @param val
     * @param comp
     */
    MArray.differenceWith = function (arr, val, comp) { return arr.filter(function (a) { return val.findIndex(function (b) { return comp(a, b); }) === -1; }); };
    /**
     * 数组去重
     * @param arr
     */
    MArray.distinctValuesOfArray = function (arr) {
        var temp = [];
        var index = [];
        var l = arr.length;
        for (var i = 0; i < l; i++) {
            for (var j = i + 1; j < l; j++) {
                if (arr[i] === arr[j]) {
                    i++;
                    j = i;
                }
            }
            temp.push(arr[i]);
            index.push(i);
        }
        return temp;
    };
    return MArray;
}());
exports.MArray = MArray;
